# Plots a sample trajectory as generated by the overdamped Langevin equation.

# Set and load data. (Copied and shortened from freeEnergyExample.r)
beta = 100.
tau  = 0.01
N    = 100000
hKDE = 1
nKDE = 1000

data = read.table('../data/free_energy_slope.txt')
I    = order(data[,1])
data = data[I,]
R    = data[,1]
DfR  = data[,3]

# Relevant functions. (Copied and shortened from freeEnergyExample.r)
printf <- function(...) cat(sprintf(...))

idx <- function(r)
{
  N = 1:length(R)
  I = max(N[R <= r])
  
  id = I
  if(id == length(R))
    id = id-1
    
  return(id);
}

Df <- function(x)
{
  Rx  = sqrt(x[1]^2 + x[2]^2)
  rIds  = unlist(lapply(Rx,idx))
  
  lambda = (Rx - R[rIds])/(R[rIds+1]-R[rIds])
  Dfr = (1-lambda)*DfR[rIds] + lambda*DfR[rIds+1]
  Rx[Rx == 0] = Inf
  Dfx = c(x[1]*Dfr/Rx, x[2]*Dfr/Rx)
  
  return(Dfx)
}

eulerMaruyama <- function(tau, N)
{
  x   = matrix(nrow=N,ncol=2)
  G   = matrix(rnorm(N*2),nrow=N,ncol=2)
  x[1,] = c(0,0)
  if(N > 1)
    for(i in 2:N)
    {
      x[i,] = x[i-1,] - tau*Df(x[i-1,]) + sqrt(2*tau/beta) * G[i,]
      rx = (x[i,1]^2 + x[i,2]^2)
      while(rx > max(R))
      {
        x[i,] = x[i,] * (2*max(R)/rx-1)
        rx = (x[i,1]^2 + x[i,2]^2)
      }
    }
    
  return(x)
}


###
# Actual Code
###
filename = 'free_energy_trajectory'
pdf_name = sprintf('../gfx/%s.pdf',filename)
pdf(pdf_name)

# Config.
require(ggplot2)
require(MASS)
require(munsell)
require(viridis)

Tmax  = N*tau
printf('Using T=%.4g, tau=%.4g, N=%d\n', Tmax, tau, N)

# Get a trajectory and turn it into a frame.
trajectory = eulerMaruyama(tau,N)
trajectory = data.frame(x=trajectory[,1], y=trajectory[,2])


# Compute a 2D kernel density estimate.
kde <- kde2d(trajectory$x, trajectory$y, h=hKDE, n=nKDE, lims=c(-1,1,-1,1))

# Put the KDE data into a frame.
# Remove all entries outside the unit circle.
X = c(outer(kde$x,kde$y,function(a,b) a))
Y = c(outer(kde$x,kde$y,function(a,b) b))
Z = c(kde$z)

R = sqrt(X^2+Y^2)
I = (R>1)
Z[I] = NA

D <- data.frame(X,Y,Z)

# Execute the actual plot.
print( c(min(D$Z, na.rm=T), max(D$Z,na.rm=T)) )
colors <- viridis(100)
v <- (
  ggplot(D, aes(D$X, D$Y, z = D$Z))
  + geom_raster(aes(fill = D$Z), show.legend=FALSE)
#~   + geom_path(data=trajectory,aes(x, y, z=NA), color=rgb(0,0,0,alpha=.5), size=0.1)
  + geom_point(data=trajectory,aes(x, y, z=NA), color=rgb(0,0,0,alpha=.025), size=0.1)
#~   + theme(panel.background = element_rect(fill = 'white', colour = 'white'))
#~   + scale_fill_continuous(na.value='white')
  + scale_fill_gradientn(colours=colors, na.value='white', limits=c(-0.4,max(D$Z,na.rm=T)))
  + theme(axis.title.x = element_blank(), axis.text.x = element_blank(), axis.ticks.x = element_blank())
  + theme(axis.title.y = element_blank(), axis.text.y = element_blank(), axis.ticks.y = element_blank())
  + theme(plot.margin = unit(c(-.9,-.9,-1,-1), "cm"))
)
print(v)


# Close file
dev.off()
